<?php
// Copyright 2014 Eskiso

if (!defined("IN_ESOTALK")) exit;

ET::$pluginInfo["Youtube"] = array(
	"name" => "Youtube",
	"description" => "Converts youtube links to embed video.",
	"version" => "0.1",
	"author" => "Manuel 'Eskiso'",
	"authorEmail" => "admin@eskiso.net",
	"authorURL" => "http://www.eskiso.net",
	"license" => "GPLv2"
);

class ETPlugin_Youtube extends ETPlugin {

public function handler_conversationController_renderBefore($sender)
{
	$sender->addJSFile($this->getResource("youtube.js"));
	$sender->addCSSFile($this->getResource("youtube.css"));
}

public function handler_conversationController_getEditControls($sender, &$controls, $id)
{
	addToArrayString($controls, "youtube", "<a href='javascript:YOUtube.youtube(\"$id\");void(0)' title='".T("Youtube")."' class='youtube-l'><span>".T("Youtube")."</span></a>", 0);
}

public function handler_format_beforeFormat($sender)
{
	$hideBlock = create_function('&$blockFixedContents, $contents', '
		$blockFixedContents[] = $contents;
		return "</p><pre></pre><p>";');
	$hideInline = create_function('&$inlineFixedContents, $contents', '
		$inlineFixedContents[] = $contents;
		return "<code></code>";');

	$this->blockFixedContents = array();
	$this->inlineFixedContents = array();

	$regexp = "/(.*)^\s*\[code\]\n?(.*?)\n?\[\/code]$/imse";
	while (preg_match($regexp, $sender->content)) {
		if ($sender->inline) $sender->content = preg_replace($regexp, "'$1' . \$hideInline(\$this->inlineFixedContents, '$2')", $sender->content);
		else $sender->content = preg_replace($regexp, "'$1' . \$hideBlock(\$this->blockFixedContents, '$2')", $sender->content);
	}

	// Inline-level [fixed] tags will become <code>.
	$sender->content = preg_replace("/\[code\]\n?(.*?)\n?\[\/code]/ise", "\$hideInline(\$this->inlineFixedContents, '$1')", $sender->content);
}

public function handler_format_format($sender)
{

	$senderr = preg_replace("|\[youtube\](.*?)\[/youtube\]|si","$1" , $sender->content);
	$youtube_link = preg_match("#(?<=v=)[a-zA-Z0-9-]+(?=&)|(?<=v\/)[^&\n]+(?=\?)|(?<=v=)[^&\n]+|(?<=youtu.be/)[^&\n]+#", $senderr, $matches);    

	$omgf = '<iframe width=350 height=250 src="http://www.youtube.com/embed/'.$matches[0].'" frameborder=0 allowfullscreen></iframe>';

	$sender->content = preg_replace("/\[youtube\](.*?)\[\/youtube\]/i", $omgf , $sender->content);

}


public function handler_format_afterFormat($sender)
{
	// Retrieve the contents of the inline <code> tags from the array in which they are stored.
	$sender->content = preg_replace("/<code><\/code>/ie", "'<code>' . array_shift(\$this->inlineFixedContents) . '</code>'", $sender->content);

	// Retrieve the contents of the block <pre> tags from the array in which they are stored.
	if (!$sender->inline) $sender->content = preg_replace("/<pre><\/pre>/ie", "'<pre>' . array_pop(\$this->blockFixedContents) . '</pre>'", $sender->content);
}

}
